// This header includes some constants that are used in the CPU encoding/decoding C++ classes
// as well as in the GLSL shaders for GPU decoding.

#ifndef CSVOL_CONSTANTS_HPP
#define CSVOL_CONSTANTS_HPP

// 1 bit is the 'stop bit'
#define STOP_BIT 8u         // the msb (1000)_2 bit is set if we stop the "octree" refinement here
// 3 bits are the label operations
#define PARENT 0u           // use entry from parent
#define NEIGHBORX 1u        //
#define NEIGHBORY 2u        // } use value of a neighboring cell (pointing outwards)
#define NEIGHBORZ 3u        //
#define PALETTE_DELTA 4u    // reuse the palette value from DELTA+1 entries earlier, DELTA is the next value in the stream
#define PALETTE_ADV 5u      // use palette value and advance palette pointer
#define PALETTE_LAST 6u     // use the previous palette value

#define INVALID 0xFFFFFFFF

#endif // CSVOL_CONSTANTS_HPP
